import pandas as pd
import numpy as np

def missingValues(data):
    variable_name = []
    total_value = []
    total_missing_value = []
    missing_value_rate = []
    unique_value_list = []
    total_unique_value = []
    data_type = []

    for col in data.columns:
        variable_name.append(col)
        data_type.append(data[col].dtype)
        total_value.append(data[col].shape[0])
        total_missing_value.append(data[col].isnull().sum())
        missing_value_rate.append(
            round(data[col].isnull().sum()/data[col].shape[0], 4))
        unique_value_list.append(data[col].unique())
        total_unique_value.append(len(data[col].unique()))

    missing_data = pd.DataFrame({"Variable": variable_name,
                                 "#_Total_Value": total_value,
                                "#_Total_Missing_Value": total_missing_value,
                                 "%_Missing_Value_Rate": missing_value_rate,
                                 "Data_Type": data_type, 
                                 "Unique_Value": unique_value_list,
                                 "Total_Unique_Value": total_unique_value
                                 })

    missing_data = missing_data.set_index("Variable")
    return missing_data.sort_values("#_Total_Missing_Value", ascending=False)

def outliers(df):
    numeric_columns = df.select_dtypes(include=np.number).columns.tolist()
    for cols in numeric_columns:
        print(f"\n\n {cols} \n")
        mean = np.mean(df[cols])
        std = np.std(df[cols])
        print('mean is', mean)
        print('std. deviation is', std)
        threshold = 3
        outlier = []
        for i in df[cols]:
            z = (i-mean)/std
            if z > threshold:
                outlier.append(i)
        if len(outlier) != 0:
          print('outliers are', outlier)
        else:
          print("No Outliers")
